real function DF64(F, H)
!   F,  ,
!      .
real, intent(in):: F(:), H
double precision S
integer i, n
!begin
    n=size(F)
    if(n<6) then
        if(n<5) then
            if(n<4) then
                if(n<3) then
                    if(n<2) then
                        DF64=0.0; goto 10
                    endif
                    DF64=0.5*H*(F(1)+F(2)); goto 10
                endif
                DF64=(H/3.0)*(F(1)+4.0*F(2)+F(3)); goto 10
            endif
            DF64=(3.0*H/8.0)*(F(1)+3.0*F(2)+3.0*F(3)+F(4)); goto 10
        endif
        DF64=(2.0*H/45.0)*(7.0*F(1)+32.0*F(2)+12.0*F(3)+32.0*F(4)+7.0*F(5))
10      return
    endif
    S=0.375D0*(F(1)+F(n))+(7.0D0/6.0D0)*(F(2)+F(n-1))+(23.0D0/24.0D0)*(F(3)+F(n-2))
    do i=4, n-3
        S=S+F(i)
    enddo
    DF64=sngl(H*S)
    return
end function DF64
